
public class BenchmarkResult {
	public double precision;
	public double recall;
	public double fscore;
	public double overall;
	public int biggestSubstreeSize;
	public double structuralOverlap;
	public double structuralProximity;
	public int nbElementsIdealSchema;
	public int nbElementsMatcherSchema;
	public int nbCommonElementsInSubtrees;
	public double schemaProximity;
	
	void calculateFScore() {
		if(precision+recall != 0.0) fscore = (2.0 * precision * recall)/(precision+recall);
		else fscore = 0.0;
	}
	
	void calculateOverall() {
		if(precision != 0.0) overall = recall * (2.0 - (1.0/precision));
		else overall = -1.0;
		if(overall<-1.0) overall = -1.0;
	}
	
	public BenchmarkResult() {
		precision = 0.0;
		recall = 0.0;
		fscore = 0.0;
		overall = 0.0;
		biggestSubstreeSize = 0;
		structuralOverlap = 0.0;
		structuralProximity = 0.0;
		nbElementsIdealSchema = 0;
		nbElementsMatcherSchema = 0;
		nbCommonElementsInSubtrees = 0;
		schemaProximity = 0.0;
	}
}
