import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class COMAWrapper implements IWrapper {

	public String inputMappingPath, outputMappingPath;
	
	public COMAWrapper(String imp, String omp) {
		inputMappingPath = imp;
		outputMappingPath = omp;
	}
	
	public String extractElementFromPath(String s) {
		int i = s.lastIndexOf(".");
		System.out.println(s);
		if(i>=0 && i+1<s.length()) return s.substring(i+1);
		else return s;
	}
	
	public void transformSetsOfMappings() {
		String s; // to read lines in the file
		try {
			BufferedReader buff = new BufferedReader(new FileReader(inputMappingPath));
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputMappingPath));
			while(null != (s = buff.readLine())) {
				if(s.startsWith(" - ")) {
					String []tabS = s.split(" ");
					bw.write(extractElementFromPath(tabS[2]));
					bw.write(" ; ");
					String t = extractElementFromPath(tabS[4]);
					bw.write(t.substring(0, t.length()-1));
					bw.write(" ; ");
					bw.write(tabS[5]);
					bw.newLine();
				}
			}
			buff.close();
			bw.close();
		} catch(IOException exc) { 
			System.out.println("Mapping file error : "+exc.getMessage()); }
	}			
}
