import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

public class ContentHandlerParserFeatures implements ContentHandler
{	
	String doc;
	SchemaContentStructure scc;
	boolean inFeatures = false;

	public ContentHandlerParserFeatures(String document, SchemaContentStructure sc)
	{ 
		doc = document;
		scc = sc;
	}

	public void setDocumentLocator(Locator locator)
	{}

	public void startDocument() throws SAXException
	{}

	public void endDocument() throws SAXException {
		if(scc.nodesLabels.size()!=scc.nodesContent.size())
			System.out.println("Warning: an error occured while parsing the xml schema !");
  	}

	public void startPrefixMapping(String prefix, String uri) throws SAXException
	{}

	public void endPrefixMapping(String prefix) throws SAXException
	{}
	
	public void startElement(String namespaceURI, String localName, String qualifiedName, Attributes atts)
	{
		if(inFeatures) scc.nodesLabels.add(qualifiedName);
		if(qualifiedName.equals("features")) {
			inFeatures = true;
		}
	}

	public void endElement(String namespaceURI, String localName, String qualifiedName) throws SAXException
	{
		if(qualifiedName.equals("features")) inFeatures = false;
	}

	public void characters(char[] text, int start, int length) throws SAXException
	{
		if(inFeatures)
		{
			String s = new String(text, start, length);
			if(!s.equals("\n")) scc.nodesContent.add(s);
			//System.out.println("read : "+s);
		}
	}

	public void ignorableWhitespace(char[] text, int start, int length) throws SAXException
	{}

	public void processingInstruction(String target, String data) throws SAXException
	{}

	public void skippedEntity(String name) throws SAXException
	{}
}