import javax.swing.tree.DefaultMutableTreeNode;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

public class ContentHandlerParserSchema implements ContentHandler
{	
	String doc;
	DefaultMutableTreeNode root, currentParent;
	
	public ContentHandlerParserSchema(String document)
	{ 
		doc = document;
		root = new DefaultMutableTreeNode(document);
		currentParent = root;
	}

	public void setDocumentLocator(Locator locator) {}

	public void startDocument() throws SAXException {}

	public void endDocument() throws SAXException {
		// removing the element schema which is root
		//root = (DefaultMutableTreeNode) root.getChildAt(0);
		root.setUserObject("ROOT");
	}

	public void startPrefixMapping(String prefix, String uri) throws SAXException {}

	public void endPrefixMapping(String prefix) throws SAXException {}
	
	public void startElement(String namespaceURI, String localName, String qualifiedName, Attributes atts)
	{
       	String name="";
        String attName, attValue;
        if(localName.equals("element")) {
        	for(int i=0;i<atts.getLength();i++)// analysing attributes
        	{
        		attName = atts.getQName(i);
        		attValue = atts.getValue(i);
        		if(attName.toLowerCase().equals("name")) name=attValue;
        		else if(attName.toLowerCase().equals("ref")) name=attValue;
        	}
        	if(!name.equals(""))
        	{
        		DefaultMutableTreeNode temp = new DefaultMutableTreeNode(name);
        		currentParent.add(temp);
        		currentParent = temp;
        	}
        }
	}

	public void endElement(String namespaceURI, String localName, String qualifiedName) throws SAXException
	{
		if(currentParent.getParent() != null)
			currentParent = (DefaultMutableTreeNode) currentParent.getParent();
	}

	public void characters(char[] text, int start, int length) throws SAXException {}

	public void ignorableWhitespace(char[] text, int start, int length) throws SAXException {}

	public void processingInstruction(String target, String data) throws SAXException {}

	public void skippedEntity(String name) throws SAXException {}
}