import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Stack;

public class ConvertAsciiTreeTool {
	BufferedReader in;
	PrintWriter out;
	String data;
	Stack <String>pile;
	File outputFile;

	public ConvertAsciiTreeTool(String asciiTreePath) {
		try {
			in = new BufferedReader(new FileReader(asciiTreePath));
			// first 2 lines are skipped
			in.readLine();
			in.readLine();
			data = in.readLine();
			outputFile = new File(asciiTreePath+".xsd");
			outputFile.createNewFile();
			out = new PrintWriter(new BufferedWriter(new FileWriter(outputFile)));
		}
		catch(IOException ioe) {System.out.println("Ascii tree path is not valid !");}
	}
	
	public void writeBuffer(String s) {
		out.println(s);
	}
	
	public boolean convert() {
		if(data==null) return false;
		String []tabData = data.split(",");
		String currentString;
		pile = new Stack<String>();
		writeBuffer("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		writeBuffer("<schema elementFormDefault=\"qualified\" xmlns:xsd=\"http://www.w3.org\" xmlns=\"http://www.w3.org\">");
		for(int i=0; i<tabData.length; i++) {
			currentString = tabData[i].trim();
			if(currentString.equals(")") && !pile.empty()) {
				pile.pop();
				writeBuffer("</element>");
			}
			else if(currentString.startsWith("(")) {
				currentString = currentString.substring(1).trim();
				pile.push(currentString);
				writeBuffer("<element name=\""+currentString+"\">");
			}
			else if(currentString.length()>0) {
				currentString = currentString.trim();
				pile.push(currentString);
				writeBuffer("<element name=\""+currentString+"\">");
			}
		}
		while(!pile.empty()) {pile.pop(); writeBuffer("</element>");}
		writeBuffer("</schema>");
		out.close();
		return true;
	}
}
